*+
*+
*+    Source Module => D:\INCOMING\GETSKIP.PRG
*+
*+    Copyright (C) 1997, Phil Barnett. All Rights Reserved Worldwide.
*+
*+    Functions: Function getsjump()
*+               Function allval()
*+               Function doSomeThing()
*+               Function clearAllgets()
*+               Function showUsAScreen()
*+               Function runSaver()
*+               Function centerString()
*+
*+    Reformatted by Click! 1.13b3 on May-25-1998 at  1:48 pm
*+
*+

/*

Rick Fleischmann wrote:

> Can someone post or email me a code snippet dealing with how to jump
> from, in a getlist, getlist[1] to, say, getlist[6] based on validation
> result of getlist[1]? I still want the user to be able to cursor up/down
> through the same getlist; just also want him to jump to an
> out-of-sequence one if need be.
>
> I know this has got something to do with getfocus() and killfocus()
> methods,
> but can't seem to make it work.
> --
> ==================================================
> Rick Fleischmann
> rickf@surfen.net
>
> Work as if you don't need the money...
> Love as if you've never been hurt...
> Dance as if nobody is watching...
>
> "Programming proves that Natural Selection is true,
> since every time I've idiot-proofed a program,
> a better idiot shows up."

Rick and others, I have attached a sample program. You do not evere have to
modify getsys.prg to make the get system jump through hoops.

                Mark Carew

*/

#INCLUDE "common.CH"
#INCLUDE "INKEY.CH"
#INCLUDE "setcurs.CH"

#DEFINE CASCADECOLOR         "G+/N,N/G*,,,W/N"
#DEFINE CENTERSCREENCOLOR    "BG+/B,B+/BG,,,W/B"
#DEFINE DATAFIELDGETCOLOR    "W+/B,N/R*,,,W/B"
#DEFINE FIRSTMENUCOLOR       "GR+/N,N/GR*,,,N/W*"
#DEFINE VIRTUALCOLOR         "N/RB*,RB+/N"

//    Courtesy of   DOWNS SOFTWARE AUSTRALIA
//       40 NorthView Outlook
//       Moorooka
//       Queensland 4105
//       Australia

//       Email    m.carew@qut.edu.au

//       Phs Australia  07-32559430 07-38487352

//  Author   Mark Carew     02-May-98
//       11:03am    Eastern Standard Time

//   Clipper getsjump /n /w  (no explicit starting procedure / warnings)
//   Blinker fi getsjump

/*

Shows how to jump from get to get according to postblock (valid)
Notice that readmodal handles all of oGet:killfocus(), oGet:settle()
etc.

Look at the program called getsys.prg supplied with clipper system
source code.

IF you enter a number in a field it will jump to that get.
To clear this effect any other value except 1 thru 7 must be entered.

The last field is a get button field you can type anything you wish
into it and it skips returning its unchanged value, but if you press
F6 is runs the function contained in the gets name instance variable

Entering 'X' in any of the seven ordinary data entry fields toggles
another screen data entry field between entry and display only

Currently I Have 3,630 clipper programs available as solutions.

*/
static nPosStatic
static getlist    := {}

//    getsjump.exe  /n in compile options is necessary

*+
*+
*+    Function getsjump()
*+
*+
*+
function getsjump()

local cGet1       := " "
local cGet2       := " "
local cGet3       := " "
local cGet4       := " "
local cGet5       := " "
local cGet6       := " "
local cGet7       := " "
local cGet8       := chr( 21 )
local cOldColor   := setcolor( CASCADECOLOR )
local cSaveScreen := savescreen()
local cSayField   := "Toggled  -  Entry \ Display Field  "
local nPos
local oGet

setkey( K_F6, { || doSomething() } )
setkey( K_F9, { || clearAllgets() } )
set scoreboard OFF

//   lets have all 16 colors

setblink( FALSE )

nPosStatic := 0

clear screen

setcolor( DATAFIELDGETCOLOR )

@ 01, 02 clear to 23, 78
@ 01, 02 to 23, 78

centerstring( 03, "a GET System Example by Mark Carew Downs Software Australia", "rg+/b" )
centerstring( 04, "Esc Exits", "rg+/b" )
centerstring( 05, "F9 - clear all gets", "r+/b" )

@ 07, 06 say "Get 1"                                                             
@ 07, 20 say "A number ( > 0 and < 8 ) makes Get jump"      color "bg+/b"        
@ 09, 06 say "Get 2"                                                             
@ 09, 20 say "An entry not a number ( > 0 and < 8 ) clears" color "bg+/b"        
@ 11, 06 say "Get 3"                                                             
@ 13, 06 say "Get 4"                                                             
@ 15, 06 say "Get 5"                                                             
@ 16, 20 say "Enter X in any field to open\close field Below" color "bg+/b"
@ 17, 06 say "Get 6"                                                     
@ 19, 06 say "Get 7"                                                     
@ 21, 06 say "Button"                                                    
@ 21, 20 say "Press F6 - Its a Get no change field" color "bg+/b"        

//    notice how the getlist needs to created only once
//    because readmodal does not clear the getlist
//    as does read ==> readmodal(getlist,nPos);getlist:={}

//   get variant 1

@ 07, 16 get cGet1         
getlist[ 1 ] :postblock := { || allval() }

//   get variant 2

aadd( getlist, getnew( 09, 16 ) )
getlist[ 2 ] :name      := "anythingYouWantToReferenceItBy"
getlist[ 2 ] :Block     := { | x | if( x == NIL, cGet2, cGet2 := x ) }
getlist[ 2 ] :postblock := { || allval() }

//   standard \ usual codeing

// @ 07,16 GET cGet1 valid allval()
// @ 09,16 GET cGet2 valid allval()

@ 11, 16 get cGet3 valid allval()        
@ 13, 16 get cGet4 valid allval()        
@ 15, 16 get cGet5 valid allval()        
@ 17, 16 get cGet6 valid allval()        
@ 19, 16 get cGet7 valid allval()        

//   use of a get (as a non change stop on field) calling a function

@ 21, 16 get cGet8         

//   no matter what is entered get:block always returns chr(21)
//   hence field is a get field that cannot be changed

getlist[ 8 ] :block := { | x | chr( 21 ) }

//   use of the :name instance variable of get class for storage
//   of a fucntion to be called by F6 function Key

//   could equally use :cargo instance variable of the get class

getlist[ 8 ] :name      := "showUsAScreen()"
getlist[ 8 ] :colorspec := VIRTUALCOLOR

//   example of an entry field that is enabled/disabled
//  by a some action in another get field

@ 17, 20 get cSayField         
getlist[ 9 ] :preblock := { || iif( .T., .F., .F. ) }

nPos := nPosStatic

do while TRUE

   readmodal( getlist, nPos )

   if lastkey() == K_ESC
      exit
   endif

   nPos       := nPosStatic
   nPosStatic := 0

enddo

restscreen(,,,, cSaveScreen )
setcolor( cOldColor )

setblink( FALSE )

return nil

//   postblock function use

*+
*+
*+    Function allval()
*+
*+    Called from ( getskip.prg  )   7 - function getsjump()
*+
*+
*+
function allval()

local oGet
local cGetVal
local nGetVal
local bBlock

//   get a reference to the current get field that is in focus

oGet := getactive()

//   evaluates the get set block of the current get to return its
//   stored and current thus value
//   is equivalent to

//   cGetVal := eval(oGet:block)

cGetVal := oGet:varget()

//    set the entry to another field off and on according to
//    data entered in another field

if cGetVal == "X"
   if eval( getlist[ 9 ] :preblock )
      getlist[ 9 ] :preblock := { || iif( ( .T. ), .F., .F. ) }
   else
      getlist[ 9 ] :preblock := { || iif( ( .T. ), .T., .T. ) }
   endif
endif

//   is it a numeric character

nGetVal := val( cGetVal )

//   does it lie within the range of the gets for which this
//   process applies

if nGetVal > 0 .and. nGetVal < 8

   //   make readmodal let go of the particular get

   oGet:killFocus()

   //   force exit from  the readmodal function

   readKill( TRUE )

   nPosStatic := nGetVal

endif

return TRUE

//   F6 - button process function  (virtual get field)

*+
*+
*+    Function doSomeThing()
*+
*+    Called from ( getskip.prg  )   1 - function getsjump()
*+
*+
*+
function doSomeThing()

local oGet     := getactive()
local cGetName := oGet:name
local bBlock

//   does the :name instance variable of the get contain
//   the name of a function

if empty( cGetName )

else

   if at( "()", cGetName ) > 0

      //   build a string code block for the function name
      //   and macro compile it into an evalueable code block

      bBlock := &( "{||" + cGetName + "}" )

      eval( bBlock )
      /*
*  also
*  could pass parameters to the eval
*  and return any result
*
*  e.g.
*
*  uAnyVal := eval(bBlock,aSetOfValues)
*  uAnyVal := eval(bBlock,x,y,z)
*
*  in which case bBlock would be
*
bBlock := &("{|x,y,z|" + strtran(cGetName,[()],[(x,y,z)]) + "}")
*
*  N.B. use of [] characters as string delimiters
*  as third alternative to ' or " as string delimiters
*
*  of :name instance variable of the get could contain
*  {"cResult","aFunctionToDo(x,y,z)"}
*
*  then code could be something like
*
*  ====> WARNING: this code has never tested
*  ====> WARNING: there is uncertainty in (oGet:name[1])
*
*  if valtype(oGet:name) == "A"
*     if at("(",oGet:name[2]) > 0
*        bBlock := &("{|x,y,x|" + oGet:name[2] + "}")
*        (oGet:name[1]) := eval(bBlock,uMyPar1,uMyPar2,uMyPar3)
*     endif
*  endif
*
*  where
*
* function aFunctionToDo(x,y,z)
*    *
*    local uRetval
*    *
*    .... lots of code
*    .... lots of code
*    .... lots of code
*    *
* return uRetVal
*
*/

   endif

endif

return nil

//    set key function to clear all get values

*+
*+
*+    Function clearAllgets()
*+
*+    Called from ( getskip.prg  )   1 - function getsjump()
*+
*+
*+
function clearAllgets()

local nPtr
local oGet

for nPtr := 1 to 7

   oGet := getlist[ nPtr ]
   oGet:varput( " " )
   oGet:updateBuffer()
   oGet:display()

next

return nil

//   a sample screen run from F6 button press on virtual get field

*+
*+
*+    Function showUsAScreen()
*+
*+
*+
function showUsAScreen()

local nTimeOut    := seconds()
local nNewTime    := nTimeOut
local nDiff
local cSaveScreen := savescreen()
local cOldColor   := setcolor( FIRSTMENUCOLOR )

@ 02, 00 clear to 22, 79
@ 02, 00 to 22, 79
centerstring( 03, "THIS IS GAUDY ADVERTISING", "w+/n" )
centerstring( 04, "So Far I've wasted approx       seconds on this display", "R+/n" )
centerstring( 05, "Wait for the Screen Saver to Kick in", "gr+/n" )
centerstring( 06, "Downs Software - Australia - 07-32559430", "bg+/n" )
centerstring( 07, "Using Class(y), Clipper, Objectdb, SixCdx, Visual Objects", "b+/n" )
centerstring( 08, "Customised Systems Available to manage", "gr+/n" )
centerstring( 09, "Transport cartage and haulage, Trucks, Licenses", "g+/n" )
centerstring( 10, "Fleet Tyres and Fuel, Cash Book, Phone Expenses Log", "g+/n" )
centerstring( 11, "Debtors, Creditors, Pricing, Financials, Asset Register", "g+/n" )
centerstring( 12, "Pedigree, Genealogy, Truck Soft Drink Vendor", "g+/n" )
centerstring( 13, "Workshop, Stock, Purchasing, Creditors, Work in progress", "g+/n" )
centerstring( 14, "Produce Merchant - Buy and sell within one ledger", "g+/n" )
centerstring( 15, "Pawn Brokering, Container Maintenance, Truck Maintenance", "g+/n" )
centerstring( 16, "Property Settlement", "g+/n" )
centerstring( 18, "All Systems are written using a Data " + ;
              "Driven Clipper Development Engine.", "br+/n" )
centerstring( 19, "Porting to Windows is being accomplished, by reading the", "br+/n" )
centerstring( 20, "Repository associated with the development engine and generating", "br+/n" )
centerstring( 21, "Visual Objects Source Code", "br+/n" )

do while TRUE

   inkey()

   if lastkey() == K_ESC
      exit
   endif

   nNewTime := seconds()

   nDiff := nNewTime - nTimeOut

   centerstring( 04, transform( nDiff, "###.##" ), "bg+/n" )

   if nDiff > 10

      runsaver()
      nTimeOut := seconds()

   endif

enddo

restscreen(,,,, cSaveScreen )
setcolor( cOldColor )

return nil

//   one of many source code samples

*+
*+
*+    Function runSaver()
*+
*+    Called from ( getskip.prg  )   1 - function showusascreen()
*+
*+
*+
function runSaver()

local aColors
local cDownsSoft := "CLIPPER AND VO SOFTWARE SOLUTIONS - " + ;
        "DOWNS SOFTWARE AUSTRALIA 07 32559430"
local cOldColor
local cSaveScreen   := savescreen()
local cSaveLine12
local nAcross       := 0
local nColorPointer := 1
local nDirAcross    := 1
local nDirDown      := 1
local nDown         := 0
local nEachTwo      := 0
local nKey          := 0
local nWhere
local nLen          := len( cDownsSoft )

setcursor( SC_NONE )

nWhere := nLen * - 1

aColors := { "B/W*", ;
             "BG+/N", ;
             "G+/N", ;
             "B+/N", ;
             "RG+/N", ;
             "BG/W*", ;
             "RB+/N", ;
             "G/W*", ;
             "RB/W*", ;
             "RG/W*", ;
             "W+/N", ;
             "R+/N", ;
             "N/W*" }

clear screen

cSaveLine12 := savescreen( 12, 0, 12, 79 )

do while TRUE

   @ nDown, nAcross say chr( 176 ) color aColors[ nColorPointer ]        

   if nDown == 12
      cSaveLine12 := ;
              stuff( ;
              cSaveLine12, ;
              ( nAcross * 2 ) + 1, 2, ;
              savescreen( 12, nAcross, 12, nAcross ) )
   endif

   //    fast enough

   nKey := inkey( .1 )

   if nKey != 0
      exit
   endif

   nAcross += nDirAcross
   nDown   += nDirDown

   if nDown == 12 .and. nAcross == 40
      clear screen
      cSaveLine12 := savescreen( 12, 0, 12, 79 )
   endif

   if nDown > 24

      nDirDown := - 1
      nColorPointer ++

   endif

   if nAcross > 79

      nDirAcross := - 1
      nColorPointer ++

   endif

   if nDown < 0

      nDirDown := + 1
      nColorPointer ++

   endif

   if nAcross < 0

      nDirAcross := + 1
      nColorPointer ++

   endif

   if nColorPointer > 13
      nColorPointer := 1
   endif

   nEachTwo ++

   if nEachTwo > 1

      nEachTwo := 0

      nWhere ++

      if nWhere > 79
         nWhere := nLen * - 1
      endif

      restscreen( 12, 0, 12, 79, cSaveLine12 )

      if nWhere < 0
         @ 12,  0 say right( cDownsSoft, nLen + 1 + nWhere ) color( "bg/n" )        
      else
         @ 12, nWhere say cDownsSoft color( "bg/n" )        
      endif

   endif

enddo

setcursor( SC_NORMAL )

restscreen(,,,, cSaveScreen )

return nil

//     shows a centered string at a row with a color

*+
*+
*+    Function centerString()
*+
*+    Called from ( getskip.prg  )   3 - function getsjump()
*+                                  19 - function showusascreen()
*+
*+
*+
function centerString( nTheRow, cTheString, cTheColor, lClearLine )

local nTheCol

if !empty( lClearline )
   if lClearLine
      if empty( cTheColor )
         @ nTheRow,  0 clear to nTheRow, 79
      else
         @ nTheRow,  0 say space( 80 ) color( cTheColor )        
      endif
   endif
endif

cTheString := cTheString
nTheCol    := ( 80 - len( cTheString ) ) / 2

if !empty( cTheColor )
   @ nTheRow, nTheCol say cTheString color( cTheColor )        
else
   @ nTheRow, nTheCol say cTheString         
endif

return nil

*+ EOF: GETSKIP.PRG
